<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__lpa__wifi__tko__ol_8c" kind="file" language="C++">
    <compoundname>cy_lpa_wifi_tko_ol.c</compoundname>
    <includes local="yes">string.h</includes>
    <includes local="yes" refid="cy__lpa__wifi__ol__debug_8h">cy_lpa_wifi_ol_debug.h</includes>
    <includes local="yes" refid="cy__lpa__wifi__ol_8h">cy_lpa_wifi_ol.h</includes>
    <includes local="yes" refid="cy__lpa__wifi__ol__priv_8h">cy_lpa_wifi_ol_priv.h</includes>
    <includes local="yes" refid="cy__lpa__wifi__tko__ol_8h">cy_lpa_wifi_tko_ol.h</includes>
    <includes local="yes" refid="cy__lpa__wifi__result_8h">cy_lpa_wifi_result.h</includes>
    <includes local="yes">lwip/ip.h</includes>
    <includes local="yes">whd_sdpcm.h</includes>
    <includes local="yes" refid="cy__whd__tko__api_8h">cy_whd_tko_api.h</includes>
    <includes local="yes">whd_wifi_api.h</includes>
    <includes local="yes">whd_wlioctl.h</includes>
    <includes local="yes">whd_endian.h</includes>
    <includes local="yes">whd_types.h</includes>
    <incdepgraph>
      <node id="51">
        <label>whd_types.h</label>
      </node>
      <node id="49">
        <label>whd_wlioctl.h</label>
      </node>
      <node id="44">
        <label>cy_lpa_wifi_tko_ol.c</label>
        <link refid="cy__lpa__wifi__tko__ol_8c" />
        <childnode refid="45" relation="include">
        </childnode>
        <childnode refid="46" relation="include">
        </childnode>
        <childnode refid="47" relation="include">
        </childnode>
        <childnode refid="48" relation="include">
        </childnode>
        <childnode refid="49" relation="include">
        </childnode>
        <childnode refid="50" relation="include">
        </childnode>
        <childnode refid="51" relation="include">
        </childnode>
      </node>
      <node id="47">
        <label>whd_sdpcm.h</label>
      </node>
      <node id="46">
        <label>lwip/ip.h</label>
      </node>
      <node id="45">
        <label>string.h</label>
      </node>
      <node id="50">
        <label>whd_endian.h</label>
      </node>
      <node id="48">
        <label>whd_wifi_api.h</label>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="cy__lpa__wifi__tko__ol_8c_1a7766ab0862ac6cdfec84cd80c6b26cc7" kind="define" prot="public" static="no">
        <name>USE_HW</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="24" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="24" />
      </memberdef>
      <memberdef id="cy__lpa__wifi__tko__ol_8c_1a5d1e0b8d02e2b67f1d4d151f68e173fe" kind="define" prot="public" static="no">
        <name>print_ip4</name>
        <param><defname>ipaddr</defname></param>
        <initializer>printf("%lu.%lu.%lu.%lu\n", (ipaddr) &amp; 0xff, (ipaddr) &gt;&gt; 8 &amp; 0xff, (ipaddr) &gt;&gt; 16 &amp; 0xff, (ipaddr) &gt;&gt; 24 &amp; 0xff)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="197" column="9" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="197" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="cy__lpa__wifi__tko__ol_8c_1a37e97cbca2a76636d0f4ad4bc6a7e12f" kind="variable" mutable="no" prot="public" static="yes">
        <type><ref kindref="member" refid="group__group__lpa__internal_1ga9def4ca12e21880657322882de19622b">ol_init_t</ref></type>
        <definition>ol_init_t tko_ol_init</definition>
        <argsstring />
        <name>tko_ol_init</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="41" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="41" />
      </memberdef>
      <memberdef id="cy__lpa__wifi__tko__ol_8c_1ab695b985ec5920cd80eba22c446f6b37" kind="variable" mutable="no" prot="public" static="yes">
        <type><ref kindref="member" refid="group__group__lpa__internal_1ga430866a43c3edc038156f38680ede8fd">ol_deinit_t</ref></type>
        <definition>ol_deinit_t tko_ol_deinit</definition>
        <argsstring />
        <name>tko_ol_deinit</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="42" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="42" />
      </memberdef>
      <memberdef id="cy__lpa__wifi__tko__ol_8c_1a822ec681a584289175d18cad2817b6b6" kind="variable" mutable="no" prot="public" static="yes">
        <type><ref kindref="member" refid="group__group__lpa__internal_1ga7b77ef0d7e6402fab179216dd39ec35b">ol_pm_t</ref></type>
        <definition>ol_pm_t tko_ol_pm</definition>
        <argsstring />
        <name>tko_ol_pm</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="43" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="43" />
      </memberdef>
      <memberdef id="cy__lpa__wifi__tko__ol_8c_1a418cfea17f292ef43f3050890723a49e" kind="variable" mutable="no" prot="public" static="no">
        <type>const ol_fns_t</type>
        <definition>const ol_fns_t tko_ol_fns</definition>
        <argsstring />
        <name>tko_ol_fns</name>
        <initializer>=
{
    .init = tko_ol_init,
    .deinit = tko_ol_deinit,
    .pm = tko_ol_pm,
}</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="45" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="45" />
      </memberdef>
      <memberdef id="cy__lpa__wifi__tko__ol_8c_1a6dbce9a8ad84cf43d73254030926019e" kind="variable" mutable="no" prot="public" static="no">
        <type><ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref></type>
        <definition>cy_tko_ol_cfg_t tko_ol_cfg</definition>
        <argsstring />
        <name>tko_ol_cfg</name>
        <initializer>= {

   .interval = 0,
   .retry_interval = 0,
   .retry_count = 0,
   {
       {
          .local_port = 0,
          .remote_port = 0,
          "0.0.0.0"
       }
   }
}</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="56" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="56" />
      </memberdef>
      <memberdef id="cy__lpa__wifi__tko__ol_8c_1aa48d9cb95dbc07e632725cf1e70c22c2" kind="variable" mutable="no" prot="public" static="no">
        <type>uint8_t</type>
        <definition>uint8_t tko_ol_cfg_index</definition>
        <argsstring />
        <name>tko_ol_cfg_index</name>
        <initializer>= 0</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="73" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="73" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="cy__lpa__wifi__tko__ol_8c_1a9abe7ba9e2a9dc076cddcb08c02c9340" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>int</type>
        <definition>static int tko_ol_init</definition>
        <argsstring>(void *ol, ol_info_t *info, const void *cfg)</argsstring>
        <name>tko_ol_init</name>
        <param>
          <type>void *</type>
          <declname>ol</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structol__info__t">ol_info_t</ref> *</type>
          <declname>info</declname>
        </param>
        <param>
          <type>const void *</type>
          <declname>cfg</declname>
        </param>
        <briefdescription>
<para>TCP Keepalive offload filter init function. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ol</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the ol structure.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>info</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the <ref kindref="compound" refid="structol__info__t">ol_info_t</ref> structure <ref kindref="compound" refid="structol__info__t">ol_info_t</ref>.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cfg</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the configuration.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns the execution result </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="177" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="99" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="99" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__lpa__wifi__tko__ol_8c_1a1d2ec45087a4aa17b1c6738d4addc1d9" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>void</type>
        <definition>static void tko_ol_deinit</definition>
        <argsstring>(void *ol)</argsstring>
        <name>tko_ol_deinit</name>
        <param>
          <type>void *</type>
          <declname>ol</declname>
        </param>
        <briefdescription>
<para>Remove TCP keep-alive offload filters. </para>        </briefdescription>
        <detaileddescription>
<para>No need to disable prior to removal.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ol</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the ol structure. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="195" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="189" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="189" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__lpa__wifi__tko__ol_8c_1a2b37149413f0a69a1f8b5fbd8190f7e2" inline="no" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>void</type>
        <definition>static void tko_ol_pm</definition>
        <argsstring>(void *ol, ol_pm_st_t st)</argsstring>
        <name>tko_ol_pm</name>
        <param>
          <type>void *</type>
          <declname>ol</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__lpa__internal_1ga72def6eb1649ece6f28243186df67be0">ol_pm_st_t</ref></type>
          <declname>st</declname>
        </param>
        <briefdescription>
<para>TCP keep-alive offload Power Management notification callback. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ol</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to the ol structure.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>st</parametername>
</parameternamelist>
<parameterdescription>
<para>see <ref kindref="member" refid="group__group__lpa__internal_1ga72def6eb1649ece6f28243186df67be0">ol_pm_st_t</ref>. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="280" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="213" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="213" />
      </memberdef>
      <memberdef const="no" explicit="no" id="cy__lpa__wifi__tko__ol_8c_1a03e833f04c11ee07ff26167dab3e5428" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int</type>
        <definition>int tko_ol_update_config</definition>
        <argsstring>(const char *remote_ip, uint16_t remote_port, uint16_t local_port, cy_tko_ol_cfg_t *cfg)</argsstring>
        <name>tko_ol_update_config</name>
        <param>
          <type>const char *</type>
          <declname>remote_ip</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>remote_port</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>local_port</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref> *</type>
          <declname>cfg</declname>
        </param>
        <briefdescription>
<para>Update the TCP keep-alive offload configuration list. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>remote_ip</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to IP address of TCP server.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>remote_port</parametername>
</parameternamelist>
<parameterdescription>
<para>The destination port of TCP server</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>local_port</parametername>
</parameternamelist>
<parameterdescription>
<para>The source port of the TCP client</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cfg</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to TCP keep-alive offload parameters. <ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref></para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns the execution result </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="345" bodyfile="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" bodystart="304" column="1" file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" line="304" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="16"><highlight class="preprocessor">#include<sp />"string.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="17"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_lpa_wifi_ol_debug.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="18"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_lpa_wifi_ol.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="19"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_lpa_wifi_ol_priv.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="20"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_lpa_wifi_tko_ol.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="21"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_lpa_wifi_result.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="22"><highlight class="normal" /></codeline>
<codeline lineno="23"><highlight class="normal" /><highlight class="preprocessor">#if<sp />!defined(OLM_NO_HARDWARE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="24"><highlight class="normal" /><highlight class="preprocessor">#define<sp />USE_HW</highlight><highlight class="normal" /></codeline>
<codeline lineno="25"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="26"><highlight class="normal" /></codeline>
<codeline lineno="27"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />USE_HW</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"lwip/ip.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"whd_sdpcm.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_whd_tko_api.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"whd_wifi_api.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"whd_wlioctl.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"whd_endian.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"whd_types.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="36"><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="39"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__lpa__internal_1ga9def4ca12e21880657322882de19622b">ol_init_t</ref><sp />tko_ol_init;</highlight></codeline>
<codeline lineno="42"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__lpa__internal_1ga430866a43c3edc038156f38680ede8fd">ol_deinit_t</ref><sp />tko_ol_deinit;</highlight></codeline>
<codeline lineno="43"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__lpa__internal_1ga7b77ef0d7e6402fab179216dd39ec35b">ol_pm_t</ref><sp />tko_ol_pm;</highlight></codeline>
<codeline lineno="44"><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp />ol_fns_t<sp />tko_ol_fns<sp />=</highlight></codeline>
<codeline lineno="46"><highlight class="normal">{</highlight></codeline>
<codeline lineno="47"><highlight class="normal"><sp /><sp /><sp /><sp />.init<sp />=<sp />tko_ol_init,</highlight></codeline>
<codeline lineno="48"><highlight class="normal"><sp /><sp /><sp /><sp />.deinit<sp />=<sp />tko_ol_deinit,</highlight></codeline>
<codeline lineno="49"><highlight class="normal"><sp /><sp /><sp /><sp />.pm<sp />=<sp />tko_ol_pm,</highlight></codeline>
<codeline lineno="50"><highlight class="normal">};</highlight></codeline>
<codeline lineno="51"><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="normal" /></codeline>
<codeline lineno="53"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="54"><highlight class="comment"><sp />*<sp />Global<sp />Declarations</highlight></codeline>
<codeline lineno="55"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="56"><highlight class="normal"><ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref><sp />tko_ol_cfg<sp />=<sp />{</highlight></codeline>
<codeline lineno="57"><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal"><sp /><sp /><sp />.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ac869b5fce49f3fb81b86b0998e40c930">interval</ref><sp />=<sp />0,</highlight></codeline>
<codeline lineno="59"><highlight class="normal"><sp /><sp /><sp />.retry_interval<sp />=<sp />0,</highlight></codeline>
<codeline lineno="60"><highlight class="normal"><sp /><sp /><sp />.retry_count<sp />=<sp />0,</highlight></codeline>
<codeline lineno="61"><highlight class="normal"><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="62"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="63"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.local_port<sp />=<sp />0,</highlight></codeline>
<codeline lineno="64"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.remote_port<sp />=<sp />0,</highlight></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="stringliteral">"0.0.0.0"</highlight><highlight class="normal" /></codeline>
<codeline lineno="66"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="67"><highlight class="normal"><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="68"><highlight class="normal">};</highlight></codeline>
<codeline lineno="69"><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal" /><highlight class="comment">/*<sp />tko_ol_cfg<sp />index<sp />points<sp />to<sp />an<sp />index<sp />to<sp />the<sp />TCP<sp />connection<sp />parameters</highlight></codeline>
<codeline lineno="71"><highlight class="comment"><sp />*<sp />upto<sp />maximum<sp />of<sp />MAX_TKO<sp />TCP<sp />connections<sp />supported.</highlight></codeline>
<codeline lineno="72"><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal">uint8_t<sp />tko_ol_cfg_index<sp />=<sp />0;</highlight></codeline>
<codeline lineno="74"><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="76"><highlight class="comment">*<sp />Function<sp />Prototypes</highlight></codeline>
<codeline lineno="77"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="78"><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="81"><highlight class="comment"><sp />*<sp />Function<sp />Name:<sp />tko_ol_init</highlight></codeline>
<codeline lineno="82"><highlight class="comment"><sp />****************************************************************************/</highlight></codeline>
<codeline lineno="99"><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />tko_ol_init(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*ol,<sp /><ref kindref="compound" refid="structol__info__t">ol_info_t</ref><sp />*info,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*cfg)</highlight></codeline>
<codeline lineno="100"><highlight class="normal">{</highlight></codeline>
<codeline lineno="101"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />USE_HW</highlight><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structtko__ol__t">tko_ol_t</ref><sp />*ctxt<sp />=<sp />(<ref kindref="compound" refid="structtko__ol__t">tko_ol_t</ref><sp />*)ol;</highlight></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref><sp />*tko_cfg;</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />i;</highlight></codeline>
<codeline lineno="105"><highlight class="normal"><sp /><sp /><sp /><sp />whd_result_t<sp />result;</highlight></codeline>
<codeline lineno="106"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />max;</highlight></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp />whd_tko_retry_t<sp />retry;</highlight></codeline>
<codeline lineno="108"><highlight class="normal" /></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"%s\n"</highlight><highlight class="normal">,<sp />__func__);</highlight></codeline>
<codeline lineno="110"><highlight class="normal"><sp /><sp /><sp /><sp />memset(ctxt,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(<ref kindref="compound" refid="structtko__ol__t">tko_ol_t</ref>)<sp />);</highlight></codeline>
<codeline lineno="111"><highlight class="normal" /></codeline>
<codeline lineno="112"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />cfg<sp />==<sp />NULL<sp />)</highlight></codeline>
<codeline lineno="113"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="114"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"TCP<sp />Keep<sp />Alive<sp />offload<sp />not<sp />configured!!\n"</highlight><highlight class="normal">,<sp />__func__);</highlight></codeline>
<codeline lineno="115"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />RESULT_OK;</highlight></codeline>
<codeline lineno="116"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="117"><highlight class="normal" /></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp />ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ab9645b98cf75b8e3c694f20e7dbd0cc3">cfg</ref><sp />=<sp />(<ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref><sp />*)cfg;</highlight></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp />tko_cfg<sp />=<sp />&amp;tko_ol_cfg;</highlight></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp />ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ad3dadda42d16f6f71396c72e2c0f2987">whd</ref><sp /><sp />=<sp />info-&gt;<ref kindref="member" refid="structol__info__t_1a81146b644c5eb9b2c6719976d9ef25d9">whd</ref>;</highlight></codeline>
<codeline lineno="121"><highlight class="normal" /></codeline>
<codeline lineno="122"><highlight class="normal"><sp /><sp /><sp /><sp />memcpy(&amp;tko_ol_cfg,<sp />ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ab9645b98cf75b8e3c694f20e7dbd0cc3">cfg</ref>,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(tko_ol_cfg));</highlight></codeline>
<codeline lineno="123"><highlight class="normal" /></codeline>
<codeline lineno="124"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(i<sp />=<sp />0;<sp />i<sp />&lt;<sp />MAX_TKO;<sp />i++)</highlight></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"%d<sp />local<sp />%d,<sp />"</highlight><highlight class="normal">,<sp />i,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0c22be2daaa3a4baa61bccc472d7b245">local_port</ref>);</highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"<sp /><sp /><sp />remote<sp />%d,<sp />"</highlight><highlight class="normal">,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a9e92176a589e0faea7665b3fbc1f35da">remote_port</ref>);</highlight></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"<sp /><sp /><sp />IP<sp />%s\n"</highlight><highlight class="normal">,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0b8520047f2469edea33da124e857cf5">remote_ip</ref>);</highlight></codeline>
<codeline lineno="129"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="130"><highlight class="normal" /></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp />whd_tko_max_assoc(ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ad3dadda42d16f6f71396c72e2c0f2987">whd</ref>,<sp />&amp;max);</highlight></codeline>
<codeline lineno="132"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(result<sp />!=<sp />WHD_SUCCESS)</highlight></codeline>
<codeline lineno="133"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"tko_max_assoc<sp />returned<sp />failure\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="135"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />RESULT_OK;</highlight></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="137"><highlight class="normal"><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caaae0aaa77cdc5cc4cb182b6895180bc06">LOG_OLA_LVL_INFO</ref>,<sp /></highlight><highlight class="stringliteral">"Max<sp />connection:<sp />%d\n"</highlight><highlight class="normal">,<sp />max);</highlight></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(max<sp />!=<sp />MAX_TKO)</highlight></codeline>
<codeline lineno="139"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="140"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"%s:<sp />Runtime<sp />max<sp />connections<sp />(%d)<sp />!=<sp />precompiled<sp />connections<sp />(%d)\n"</highlight><highlight class="normal">,</highlight></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__func__,<sp />max,<sp />MAX_TKO);</highlight></codeline>
<codeline lineno="142"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="143"><highlight class="normal" /></codeline>
<codeline lineno="144"><highlight class="normal"><sp /><sp /><sp /><sp />retry.tko_interval<sp />=<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ac869b5fce49f3fb81b86b0998e40c930">interval</ref>;</highlight></codeline>
<codeline lineno="145"><highlight class="normal"><sp /><sp /><sp /><sp />retry.tko_retry_interval<sp />=<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1a8fab23a40b0f3bc0a4dbc920c9dfaa2f">retry_interval</ref>;</highlight></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp />retry.tko_retry_count<sp />=<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1a33a573993dd0a6f5ddb2c247b381c585">retry_count</ref>;</highlight></codeline>
<codeline lineno="147"><highlight class="normal" /></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />params<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp />whd_tko_param(ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ad3dadda42d16f6f71396c72e2c0f2987">whd</ref>,<sp />&amp;retry,<sp />1);</highlight></codeline>
<codeline lineno="150"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(result<sp />!=<sp />WHD_SUCCESS)</highlight></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="152"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"Set<sp />whd_tko_param<sp />returned<sp />failure\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="153"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />RESULT_OK;</highlight></codeline>
<codeline lineno="154"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="155"><highlight class="normal" /></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp />memset(&amp;retry,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(retry)<sp />);</highlight></codeline>
<codeline lineno="157"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />params<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="158"><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp />whd_tko_param(ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ad3dadda42d16f6f71396c72e2c0f2987">whd</ref>,<sp />&amp;retry,<sp />0);</highlight></codeline>
<codeline lineno="159"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(result<sp />!=<sp />WHD_SUCCESS)</highlight></codeline>
<codeline lineno="160"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="161"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"Get<sp />whd_tko_param<sp />returned<sp />failure\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="162"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />RESULT_OK;</highlight></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="164"><highlight class="normal" /></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline lineno="166"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp />if<sp />((retry.tko_interval<sp />!=<sp />tko_cfg-&gt;interval)<sp />||</highlight></codeline>
<codeline lineno="167"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(retry.tko_retry_interval<sp />!=<sp />tko_cfg-&gt;retry_interval)<sp />||</highlight></codeline>
<codeline lineno="168"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(retry.tko_retry_count<sp />!=<sp />tko_cfg-&gt;retry_count))<sp />{</highlight></codeline>
<codeline lineno="169"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf("%s:<sp />Set<sp />&amp;<sp />Get<sp />values<sp />are<sp />different!\n",<sp />__func__);</highlight></codeline>
<codeline lineno="170"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf("Interval:<sp />%d\n",<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retry.tko_interval);</highlight></codeline>
<codeline lineno="171"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf("Retry_interval:<sp />%d\n",<sp /><sp /><sp />retry.tko_retry_interval);</highlight></codeline>
<codeline lineno="172"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />printf("Retry_count:<sp />%d\n",<sp /><sp /><sp /><sp /><sp /><sp />retry.tko_retry_count);</highlight></codeline>
<codeline lineno="173"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="174"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="175"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />RESULT_OK;</highlight></codeline>
<codeline lineno="177"><highlight class="normal">}</highlight></codeline>
<codeline lineno="178"><highlight class="normal" /></codeline>
<codeline lineno="179"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="180"><highlight class="comment"><sp />*<sp />Function<sp />Name:<sp />tko_ol_deinit</highlight></codeline>
<codeline lineno="181"><highlight class="comment"><sp />****************************************************************************/</highlight></codeline>
<codeline lineno="189"><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />tko_ol_deinit(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*ol)</highlight></codeline>
<codeline lineno="190"><highlight class="normal">{</highlight></codeline>
<codeline lineno="191"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />USE_HW</highlight><highlight class="normal" /></codeline>
<codeline lineno="192"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structtko__ol__t">tko_ol_t</ref><sp />*ctxt<sp />=<sp />(<ref kindref="compound" refid="structtko__ol__t">tko_ol_t</ref><sp />*)ol;</highlight></codeline>
<codeline lineno="193"><highlight class="normal"><sp /><sp /><sp /><sp />whd_tko_disable(ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ad3dadda42d16f6f71396c72e2c0f2987">whd</ref>);</highlight></codeline>
<codeline lineno="194"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="195"><highlight class="normal">}</highlight></codeline>
<codeline lineno="196"><highlight class="normal" /></codeline>
<codeline lineno="197"><highlight class="normal" /><highlight class="preprocessor">#define<sp />print_ip4(ipaddr)<sp /><sp />\</highlight></codeline>
<codeline lineno="198"><highlight class="preprocessor"><sp /><sp /><sp /><sp />printf("%lu.%lu.%lu.%lu\n",<sp />(ipaddr)<sp />&amp;<sp />0xff,<sp />(ipaddr)<sp />&gt;&gt;<sp />8<sp />&amp;<sp />0xff,<sp />(ipaddr)<sp />&gt;&gt;<sp />16<sp />&amp;<sp />0xff,<sp />(ipaddr)<sp />&gt;&gt;<sp />24<sp />&amp;<sp />0xff)</highlight><highlight class="normal" /></codeline>
<codeline lineno="199"><highlight class="normal" /></codeline>
<codeline lineno="200"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="201"><highlight class="comment"><sp />*<sp />Function<sp />Name:<sp />tko_ol_pm</highlight></codeline>
<codeline lineno="202"><highlight class="comment"><sp />****************************************************************************/</highlight></codeline>
<codeline lineno="213"><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />tko_ol_pm(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*ol,<sp /><ref kindref="member" refid="group__group__lpa__internal_1ga72def6eb1649ece6f28243186df67be0">ol_pm_st_t</ref><sp />st)</highlight></codeline>
<codeline lineno="214"><highlight class="normal">{</highlight></codeline>
<codeline lineno="215"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />USE_HW</highlight><highlight class="normal" /></codeline>
<codeline lineno="216"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structtko__ol__t">tko_ol_t</ref><sp />*ctxt<sp />=<sp />(<ref kindref="compound" refid="structtko__ol__t">tko_ol_t</ref><sp />*)ol;</highlight></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref><sp />*tko_cfg<sp />=<sp />&amp;tko_ol_cfg;</highlight></codeline>
<codeline lineno="218"><highlight class="normal"><sp /><sp /><sp /><sp />whd_result_t<sp />result;</highlight></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />found<sp />=<sp />0;</highlight></codeline>
<codeline lineno="220"><highlight class="normal" /></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(st<sp />==<sp /><ref kindref="member" refid="group__group__lpa__internal_1gga72def6eb1649ece6f28243186df67be0a4aabf880ab6e5db6b2f7c73cd650baec">OL_PM_ST_GOING_TO_SLEEP</ref>)</highlight></codeline>
<codeline lineno="222"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="223"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Sleeping<sp />case<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="224"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caaae0aaa77cdc5cc4cb182b6895180bc06">LOG_OLA_LVL_INFO</ref>,<sp /></highlight><highlight class="stringliteral">"TKO:<sp />Enter<sp />Sleep\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="225"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal"><sp />(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />i<sp />=<sp />0;<sp />i<sp />&lt;<sp />MAX_TKO;<sp />i++)</highlight></codeline>
<codeline lineno="226"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="227"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />whd_tko_activate(ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ad3dadda42d16f6f71396c72e2c0f2987">whd</ref>,<sp />i,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0c22be2daaa3a4baa61bccc472d7b245">local_port</ref>,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a9e92176a589e0faea7665b3fbc1f35da">remote_port</ref>,</highlight></codeline>
<codeline lineno="228"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0b8520047f2469edea33da124e857cf5">remote_ip</ref>);</highlight></codeline>
<codeline lineno="229"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(result<sp />!=<sp />WHD_SUCCESS)</highlight></codeline>
<codeline lineno="230"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="231"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"%s:<sp />No<sp />such<sp />connection:<sp />%s<sp />local<sp />%d<sp />remote<sp />%d\n"</highlight><highlight class="normal">,<sp />__func__,</highlight></codeline>
<codeline lineno="232"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0b8520047f2469edea33da124e857cf5">remote_ip</ref>,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0c22be2daaa3a4baa61bccc472d7b245">local_port</ref>,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a9e92176a589e0faea7665b3fbc1f35da">remote_port</ref>);</highlight></codeline>
<codeline lineno="233"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="234"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="235"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="236"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />found++;</highlight></codeline>
<codeline lineno="237"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa909182644928c71917421d3c391f7e01">LOG_OLA_LVL_WARNING</ref>,<sp /></highlight><highlight class="stringliteral">"%s:<sp />Activated:<sp />%s<sp />local<sp />%d<sp />remote<sp />%d\n"</highlight><highlight class="normal">,<sp />__func__,</highlight></codeline>
<codeline lineno="238"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0b8520047f2469edea33da124e857cf5">remote_ip</ref>,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0c22be2daaa3a4baa61bccc472d7b245">local_port</ref>,<sp />tko_cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[i].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a9e92176a589e0faea7665b3fbc1f35da">remote_port</ref>);</highlight></codeline>
<codeline lineno="239"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="240"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="241"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!found)</highlight></codeline>
<codeline lineno="242"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="243"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"TKO<sp />PM:<sp />No<sp />connections<sp />to<sp />enable.\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="244"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="245"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="246"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="247"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />whd_tko_enable(ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ad3dadda42d16f6f71396c72e2c0f2987">whd</ref>);</highlight></codeline>
<codeline lineno="248"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(result<sp />!=<sp />WHD_SUCCESS)</highlight></codeline>
<codeline lineno="249"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="250"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"%s:<sp />whd_tko_enable<sp />returns<sp />failure\n"</highlight><highlight class="normal">,<sp />__func__);</highlight></codeline>
<codeline lineno="251"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="252"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="253"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"%s:<sp />Sleep<sp />with<sp />TKO_ENABLED\n"</highlight><highlight class="normal">,<sp />__func__);</highlight></codeline>
<codeline lineno="255"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="257"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="258"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Waking<sp />case<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="261"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(1)</highlight></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="263"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"%s:<sp />Wakeup<sp />and<sp />disable<sp />TKO\n"</highlight><highlight class="normal">,<sp />__func__);</highlight></codeline>
<codeline lineno="264"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp />whd_tko_disable(ctxt-&gt;<ref kindref="member" refid="structtko__ol__t_1ad3dadda42d16f6f71396c72e2c0f2987">whd</ref>);</highlight></codeline>
<codeline lineno="265"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(result<sp />!=<sp />WHD_SUCCESS)</highlight></codeline>
<codeline lineno="266"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="267"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"%s:<sp />whd_tko_disable<sp />returned<sp />failure\n"</highlight><highlight class="normal">,<sp />__func__);</highlight></codeline>
<codeline lineno="268"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="269"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="270"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="271"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caaae0aaa77cdc5cc4cb182b6895180bc06">LOG_OLA_LVL_INFO</ref>,<sp /></highlight><highlight class="stringliteral">"%s:<sp />TKO_DISABLE<sp />success\n"</highlight><highlight class="normal">,<sp />__func__);</highlight></codeline>
<codeline lineno="272"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="273"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="274"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="275"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="276"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"Leaving<sp />Enabled\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="277"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="278"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="279"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="280"><highlight class="normal">}</highlight></codeline>
<codeline lineno="281"><highlight class="normal" /></codeline>
<codeline lineno="282"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="283"><highlight class="comment"><sp />*<sp />Function<sp />Name:<sp />tko_ol_update_config</highlight></codeline>
<codeline lineno="284"><highlight class="comment"><sp />****************************************************************************/</highlight></codeline>
<codeline lineno="304"><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />tko_ol_update_config(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">char</highlight><highlight class="normal"><sp />*remote_ip,<sp />uint16_t<sp />remote_port,<sp />uint16_t<sp />local_port,<sp /><ref kindref="compound" refid="structcy__tko__ol__cfg__t">cy_tko_ol_cfg_t</ref><sp />*cfg<sp />)</highlight></codeline>
<codeline lineno="305"><highlight class="normal">{</highlight></codeline>
<codeline lineno="306"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__tko__ol__connect__t">cy_tko_ol_connect_t</ref><sp />*tko_ol_connect_params<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="307"><highlight class="normal" /></codeline>
<codeline lineno="308"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />(<sp />remote_ip<sp />==<sp />NULL<sp />)<sp />||<sp />(<sp />remote_port<sp />==<sp />0)<sp />||<sp />(<sp />local_port<sp />==<sp />0<sp />)<sp />||<sp />(<sp />cfg<sp />==<sp />NULL<sp />)<sp />)</highlight></codeline>
<codeline lineno="309"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="310"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa28cfe3ac0a59e4b1eb5fcc8bb66ea448">LOG_OLA_LVL_ERR</ref>,<sp /></highlight><highlight class="stringliteral">"TCP<sp />Keep<sp />Alive<sp />offload<sp />configuration<sp />is<sp />NULL!!\n"</highlight><highlight class="normal">,<sp />__func__);</highlight></codeline>
<codeline lineno="311"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />RESULT_OK;</highlight></codeline>
<codeline lineno="312"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="313"><highlight class="normal" /></codeline>
<codeline lineno="314"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*</highlight></codeline>
<codeline lineno="315"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />if<sp />the<sp />API<sp />is<sp />called<sp />many<sp />times<sp />more<sp />than</highlight></codeline>
<codeline lineno="316"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />max<sp />TCP<sp />connections<sp />then<sp />update<sp />the<sp />first<sp />index</highlight></codeline>
<codeline lineno="317"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*</highlight></codeline>
<codeline lineno="318"><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="319"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<sp />tko_ol_cfg_index<sp />==<sp />MAX_TKO<sp />)</highlight></codeline>
<codeline lineno="320"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="321"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tko_ol_cfg_index<sp />=<sp />0;</highlight></codeline>
<codeline lineno="322"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="323"><highlight class="normal" /></codeline>
<codeline lineno="324"><highlight class="normal"><sp /><sp /><sp /><sp />tko_ol_connect_params<sp />=<sp />&amp;tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[tko_ol_cfg_index];</highlight></codeline>
<codeline lineno="325"><highlight class="normal"><sp /><sp /><sp /><sp />memset(tko_ol_connect_params,<sp />0,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[tko_ol_cfg_index]));</highlight></codeline>
<codeline lineno="326"><highlight class="normal"><sp /><sp /><sp /><sp />memcpy(tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[tko_ol_cfg_index].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0b8520047f2469edea33da124e857cf5">remote_ip</ref>,<sp />remote_ip,<sp />strlen(remote_ip));</highlight></codeline>
<codeline lineno="327"><highlight class="normal"><sp /><sp /><sp /><sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[tko_ol_cfg_index].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a9e92176a589e0faea7665b3fbc1f35da">remote_port</ref><sp />=<sp />remote_port;</highlight></codeline>
<codeline lineno="328"><highlight class="normal"><sp /><sp /><sp /><sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[tko_ol_cfg_index].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0c22be2daaa3a4baa61bccc472d7b245">local_port</ref><sp /><sp />=<sp />local_port;</highlight></codeline>
<codeline lineno="329"><highlight class="normal" /></codeline>
<codeline lineno="330"><highlight class="normal"><sp /><sp /><sp /><sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ac869b5fce49f3fb81b86b0998e40c930">interval</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ac869b5fce49f3fb81b86b0998e40c930">interval</ref>;</highlight></codeline>
<codeline lineno="331"><highlight class="normal"><sp /><sp /><sp /><sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1a33a573993dd0a6f5ddb2c247b381c585">retry_count</ref><sp /><sp /><sp /><sp />=<sp />cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1a33a573993dd0a6f5ddb2c247b381c585">retry_count</ref>;</highlight></codeline>
<codeline lineno="332"><highlight class="normal"><sp /><sp /><sp /><sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1a8fab23a40b0f3bc0a4dbc920c9dfaa2f">retry_interval</ref><sp />=<sp />cfg-&gt;<ref kindref="member" refid="structcy__tko__ol__cfg__t_1a8fab23a40b0f3bc0a4dbc920c9dfaa2f">retry_interval</ref>;</highlight></codeline>
<codeline lineno="333"><highlight class="normal" /></codeline>
<codeline lineno="334"><highlight class="normal"><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"\nUpdating...\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="335"><highlight class="normal"><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"%d:<sp />%s,<sp />"</highlight><highlight class="normal">,<sp />tko_ol_cfg_index,<sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[tko_ol_cfg_index].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0b8520047f2469edea33da124e857cf5">remote_ip</ref>);</highlight></codeline>
<codeline lineno="336"><highlight class="normal"><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"Local<sp />%d,<sp />"</highlight><highlight class="normal">,<sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[tko_ol_cfg_index].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a0c22be2daaa3a4baa61bccc472d7b245">local_port</ref>);</highlight></codeline>
<codeline lineno="337"><highlight class="normal"><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"Remote<sp />%d\n"</highlight><highlight class="normal">,<sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ad4979c12e1b68e5432f3c806ef2da447">ports</ref>[tko_ol_cfg_index].<ref kindref="member" refid="structcy__tko__ol__connect__t_1a9e92176a589e0faea7665b3fbc1f35da">remote_port</ref>);</highlight></codeline>
<codeline lineno="338"><highlight class="normal"><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"Interval:%d<sp />Retry_interval:%d<sp />Retry_count:%d\n"</highlight><highlight class="normal">,</highlight></codeline>
<codeline lineno="339"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1ac869b5fce49f3fb81b86b0998e40c930">interval</ref>,<sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1a8fab23a40b0f3bc0a4dbc920c9dfaa2f">retry_interval</ref>,<sp />tko_ol_cfg.<ref kindref="member" refid="structcy__tko__ol__cfg__t_1a33a573993dd0a6f5ddb2c247b381c585">retry_count</ref><sp />);</highlight></codeline>
<codeline lineno="340"><highlight class="normal"><sp /><sp /><sp /><sp />OL_LOG_TKO(<ref kindref="member" refid="group__group__loglevel__enum_1ggaa45e959559f8cd7cad6413f0f6e759caa26b3868238e0db241dad3cb0fd4fa6c2">LOG_OLA_LVL_DEBUG</ref>,<sp /></highlight><highlight class="stringliteral">"Done<sp />\n\n"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="341"><highlight class="normal" /></codeline>
<codeline lineno="342"><highlight class="normal"><sp /><sp /><sp /><sp />tko_ol_cfg_index++;</highlight></codeline>
<codeline lineno="343"><highlight class="normal" /></codeline>
<codeline lineno="344"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />RESULT_OK;</highlight></codeline>
<codeline lineno="345"><highlight class="normal">}</highlight></codeline>
<codeline lineno="346"><highlight class="normal" /></codeline>
<codeline lineno="347"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="348"><highlight class="normal">}</highlight></codeline>
<codeline lineno="349"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="350"><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/mV2grwDe/0/repo/middleware-lpa/source/cy_lpa_wifi_tko_ol.c" />
  </compounddef>
</doxygen>